/* -*- Mode: C; tab-width: 2; indent-tabs-mode: t; c-basic-offset: 2 -*-
 * File: buf.c
 *
 * Created: Tue May 27 14:54:18 2003
 *
 * $Id: buf.c,v 1.1 2003/12/13 20:59:15 mhassler Exp $
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>

#include "buf.h"
#include "defines.h"

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

inline int min(int a, int b)
{
	if(a > b)
		return b;
	else return a;
}

int dprintf(char *fmt, ...)
{
#if 0
	static char buf[4096];
	va_list ap;
	int len;

	va_start(ap, fmt);
	len = vsnprintf(buf, sizeof(buf), fmt, ap);
	va_end(ap);
	write(1, buf, len);
#endif
	return 0;
}

int dprintbuf(char *buf, int len)
{
#if 0
	write(1, buf, len);
#endif
	return 0;
}

int buf_printf(struct buffer *buf, char *fmt, ...)
{
	va_list ap;
	int len;

	if(!buf)
		return 0;
	if(!buf->data)
		return 0;

	va_start(ap, fmt);
	len = vsnprintf(&buf->data[buf->size], BUF_SIZE - buf->size, fmt, ap);
	va_end(ap);
	buf->size += len;
	if(buf->size > BUF_SIZE)
		buf->size = BUF_SIZE;
	return 1;
}

int buf_append(struct buffer *buf, char *start, int len)
{
	if(len <= 0)
		return 0;

	if(buf->size + len > BUF_SIZE)
		return 0;

	memcpy(&buf->data[buf->size], start, len);
	buf->size += len;
	return 1;
}

int buf_remove(struct buffer *buf, int len)
{
	if(len <= 0)
		return 0;

	if(buf->size < len)
		return 0;

	memmove(buf->data, &buf->data[len], buf->size - len);
	buf->size -= len;
	return 1;
}

int buf_move(struct buffer *dest, struct buffer *src, int len)
{
	if(buf_append(dest, src->data, len))
		return buf_remove(src, len);
	else
		return 0;
}
